// main.cs

// C:>csc /t:winexe main.cs


// Game Status Structure
// Animated Explosion
// Scrolling Text?
// Fix Bugs Mouse Over

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

using System.ComponentModel; // Ticker
using System.IO;

using System.Windows.Forms; // PictureBox


class Metiors
{
	private int    m_iWidth  = 0;
	private int    m_iHeight = 0;

	private Bitmap m_Image   = null;

	private bool   m_bAlive  = false;

	public float   m_xPos    = 20;
	public float   m_yPos    = 20;

	public float   m_xVelocity = 0.8f;
	public float   m_yVelocity = 0.55f;

	static long Seed; //  = DateTime.Now.Ticks;
	static Random TheRandom; // = new Random( (int)Seed);

	public void Create( String strFile )
	{
		m_Image = new Bitmap( strFile );

		m_iWidth  = m_Image.Width;
		m_iHeight = m_Image.Height;

		m_bAlive  = true;

		m_xPos = randommaker(300 - m_iWidth );
		m_yPos = randommaker(246 - 50 - 50);
		m_yPos += 50;

		//Seed = DateTime.Now.Ticks;
		//TheRandom = new Random( (int)Seed);
		m_xVelocity = (float)TheRandom.NextDouble();
		m_yVelocity = (float)TheRandom.NextDouble();

	}
	public void Update()
	{
		m_xPos += m_xVelocity;
		m_yPos += m_yVelocity;

		//-----------------
		// Update so that they bounce off the walls
		if( m_xPos <= 0 ) m_xVelocity = -m_xVelocity;
		if( (m_xPos+m_iWidth) >= 300 ) m_xVelocity = -m_xVelocity;

		if( m_yPos <= 50 ) m_yVelocity = -m_yVelocity;
		if( (m_yPos+m_iHeight) >= (246 - 50)) m_yVelocity = -m_yVelocity; // -50!
	}

	public void Render( System.Drawing.Graphics g)
	{
		if( !m_bAlive ) return;

		g.DrawImage(m_Image, new Point((int)m_xPos,(int)m_yPos) );
	}// End of Render(..)

	public int randommaker(int range) 
	{	
		//long Seed = DateTime.Now.Ticks;
		//Random TheRandom = new Random( (int)Seed);

		float fRand = TheRandom.Next(0, range);
		//int rand=(int)Math.Floor(range*fRand);
		//if (rand==0) { rand=Math.Ceil(range/2); }

		//int iRand = (int)(fRand * range);
		return (int)fRand;
	}

	public void SetRandSeed()
	{
		Seed = DateTime.Now.Ticks;
		TheRandom = new Random( (int)Seed);
	}

	public bool isInsideBox(int x, int y)
	{
		float m_xCenter = m_xPos + m_iWidth/2;
		float m_yCenter = m_yPos + m_iHeight/2;

		// Simple sphere-point intersection test.
		float xx = Math.Abs(m_xCenter - x);
		float yy = Math.Abs(m_yCenter - y);

		if( (xx < (m_iWidth/2) ) && ( yy < (m_iHeight/2)) ) return true;

		return false;
	}

};

class AWindow : System.Windows.Forms.Form
{

	private IContainer components;
	private Timer      Ticker;

	// --------------

	Metiors[] m_Metiors;
/*
	// average speed of the flying deathstones. Higher means faster
	private float floatingspeed=1;

	// width of gamezone (pixels)
	private int bgpicturewidth=300;

	// height of gamezone (pixels)
	private int bgpictureheight=246;

	// leftposition of sttusmessages in relation to gamezone
	private int statustextdistanceleft=20;

	// topposition of statusmessages in relation to gamezone
	private int statustextdistancetop=215;

	// leftposition of timesign in relation to backgroundpicture
	private int timesigndistanceleft=220;

	// topposition of timesign in relation to backgroundpicture
	private int timesigndistancetop=215;

	// leftposition of levelmarker in relation to backgroundpicture
	private int markerdistanceleft=0;

	// topposition of levelmarker in relation to backgroundpicture
	private int markerdistancetop=183;

	private int x,y;
*/
	private bool youlostgame=false;
	private bool gamehasstarted=false;
	private bool alreadycrashed=false;

	//-------------------------

	String szDisplayText = "Welcome Super Challenge";

	//------------------------

	// Simple counter variable used in scores
	float fTiming = 0.0f; 

	//------------------------

	bool m_bGameOver = true;
	//------------------------

	int m_level = 1;
	//------------------------

	/*
	String statustextcontent="";
	int tempo=20;
	float timer;
	float timetinmer;
	float starttime;
	float nowtime;
	float check_standtimer;
	*/
	int numberofimages=3;
	/*
	int stepx=new Array();
	int stepy=new Array();
    */
	

	int marginleft= 0;
	int marginright = 246;
	int margintop = 50;
	int marginbottom = 300 - 50;
	//float timer;
	//int spancontent=new Array()
	//int imgpreload=new Array()

	// --------------

    private int m_mouse_x;
    private int m_mouse_y;

	int[] coords0 = new int[] {1,1,0,198,299,198,298,1,280,63,285,71,283,80,279,91,271,102,276,134,273,160,265,176,252,187,231,188,209,174,203,157,215,132,227,118,228,111,209,110,188,91,171,78,152,80,146,85,146,93,158,97,179,100,191,107,198,122,191,142,172,152,154,151,135,137,128,131,105,130,101,135,100,156,88,173,67,183,41,183,24,172,16,146,21,125,36,111,46,108,64,105,70,99,66,84,50,77,33,82,30,85,21,87,15,77,19,67,41,60,60,60,78,67,89,89,87,107,80,116,65,124,48,126,34,137,34,153,44,165,70,164,83,151,85,129,94,116,114,111,134,113,149,124,160,133,170,133,178,126,168,115,143,113,127,97,131,71,154,61,179,60,195,70,210,88,214,90,234,92,245,99,246,120,233,142,222,155,222,159,239,169,248,166,256,152,256,124,251,96,254,92,264,80,264,69,270,62,278,60};


	private PictureBox Screen;


	void startgame() 
	{
		resetvalues();
		//startnewtime();
		statustext("Move on!");
		setValues();
	}

	void resetvalues() 
	{
		youlostgame=false;
		gamehasstarted=true;
		alreadycrashed=false;

		if( alreadycrashed ) { ; }
	}

	void statustext( String str )
	{
		this.Text = str;
	}

	void setValues() 
	{
		for (int i=0;i<=numberofimages;i++) 
		{             
			//var thisspan = eval("document.all.span"+i)
			//thisspan.innerHTML=spancontent[i]
			//var thisspan = eval("document.all.span"+(i)+".style")
			int randomposleft=marginright-marginleft;
			int startstoneleft=marginleft+randomposleft/3;
			randomposleft=randomstartposition(randomposleft);
			randomposleft=randomposleft+marginleft;
			int randompostop=marginbottom-margintop;
			randompostop=randomstartposition(randompostop);
			randompostop=randompostop+margintop;
			if (randomposleft<startstoneleft) { randomposleft+=(marginright-marginleft)/3; }
			
			// Set images positions
			//thisspan.posLeft=randomposleft
			//thisspan.posTop=randompostop
			//thisspan.visibility="visible"
		}

		for (int i=0;i<=numberofimages;i++) 
		{
			//var thisspan = eval("document.all.span"+i)
			//imgwidth[i]=thisspan.offsetWidth
			//imgheight[i]=thisspan.offsetHeight
			;
		}

		//document.all.bgpicture.style.posLeft=bgpictureposleft
		//document.all.bgpicture.style.posTop=bgpicturepostop
		//document.all.bgpicture.style.visibility="visible"
		gamehasstarted=true;
		checkmovement();
	}

	int randommaker(int range) 
	{		
		//int rand=Math.floor(range*Math.random())
		//if (rand==0) {rand=Math.ceil(range/2)}
		int rand = 3;
		return rand;
	}

	int randomstartposition(int range) 
	{		
		//int randomposition=Math.floor(range*Math.random())
		int randomposition = 2;
		return randomposition;
	}

	void checkmovement() 
	{
		if (youlostgame==false) 
		{
			checkposition();
			movepictures();
			//timer=setTimeout("checkmovement()",tempo)
		}
		else if (youlostgame) 
		{
			lostgame();
		}
	}

	void movepictures() 
	{
		for (int i=0;i<=numberofimages;i++) 
		{  
			//var thisspan=eval("document.all.span"+(i)+".style")
			//thisspan.posLeft+=stepx[i]
			//thisspan.posTop+=stepy[i]
			;
		}
	}

	void checkposition() 
	{
		for (int i=0;i<=numberofimages;i++) 
		{         
			/*
			var thisspan=eval("document.all.span"+i+".style")
			
			if (x>=thisspan.posLeft&&x<thisspan.posLeft+imgwidth[i]&&y>=thisspan.posTop&&y<thisspan.posTop+imgheight[i]) 
			{
				youlostgame=true
			}
			if (thisspan.posLeft>marginright-imgwidth[i]) 
			{
				thisspan.posLeft-=Math.abs(stepx[i]+1)
				stepx[i]=randommaker(floatingspeed)*-1	
			}
			if (thisspan.posLeft<marginleft) 
			{
				thisspan.posLeft+=Math.abs(stepx[i])
				stepx[i]=randommaker(floatingspeed)			
			}	
			if (thisspan.posTop>marginbottom-imgheight[i]) 
			{
				thisspan.posTop-=Math.abs(stepy[i])
				stepy[i]=randommaker(floatingspeed)*-1
			}
			if (thisspan.posTop<margintop) 
			{
				thisspan.posTop+=Math.abs(stepy[i])
				stepy[i]=randommaker(floatingspeed)
			}
			*/
			;
		}
	}//End checkposition(..)

	void lostgame() 
	{
		if (gamehasstarted) 
		{
			youlostgame=true;
			//clearTimeout(timer);
			//clearTimeout(timetimer);
			statustext("Crash! Start again!");
			//showcrashsign();
		}
	}


	// Called during the game running, to render metiors and other game data while
	// in play.
	void RenderGame(System.Drawing.Graphics g)
	{

		for(int i=0; i<5; i++)
		{
			m_Metiors[i].Render(g);
		}

	}

	// This is where we render to a Bitmap img, then at the end, we just
	// copy it to our screen!
	void Render()
	{
		Bitmap img = new Bitmap(300, 246);
		Graphics g = Graphics.FromImage(img);
		
		// - - Draw our image background - - - - - - - - - - - - - - -- //
		Bitmap TestImage = null;

		TestImage = new Bitmap("img/bgimage.jpg");

		int iImageWidth = TestImage.Width;
		int iImageHeight = TestImage.Height;

		//g.DrawImage(TestImage, new Point(0,0) );
		
		Rectangle destR = new Rectangle(0, 0, 300, 246);
		Rectangle srcR  = new Rectangle(0,0, TestImage.Width, TestImage.Height);

		g.DrawImage(TestImage, destR, srcR, GraphicsUnit.Pixel);

		// Or
		//Point p = new Point(10,10);
		//g.DrawImage(TestImage, p);
        // - - - - End drawing background iamge to surface - - - - - - -//

		g.DrawString( szDisplayText , this.Font, Brushes.White, 15, 215);

		// Display our timing data in the bottom right / can be used for a score
		String display = String.Format("{0:0.000}", fTiming );

		g.DrawString( display , this.Font, Brushes.White, 220, 216);

		
		if( m_bGameOver == false )
			RenderGame(g);


		// Okay, lets display which level we are on, by drawing a little circle
		// above the level number.
		int ww = 5;
		int hh = 5;
		int xx = 145;
		int yy = 179;
		//int gap = 10;
		Pen pen = new Pen( Color.Yellow, 1 );

		if( m_level == 1) xx = 145;
		if( m_level == 2) xx = 155;
		if( m_level == 3) xx = 165;
		if( m_level == 4) xx = 175;
		if( m_level == 5) xx = 186;

		g.DrawEllipse(pen, xx, yy, ww, hh);

		// Just for effects, I'll do it so when you move over the level buttons, they do 
		// an effect
		LevelButtonEffect(g);

		// Apply the graphics buffer - so we put it to our screen.
		Screen.Image = img;

	} // End of Render()


	void SetTextBoxInfo(String str )
	{
		szDisplayText = str;
	}


	// Not Used
	private void OnPaint(object sender, System.Windows.Forms.PaintEventArgs e)
	{
		System.Drawing.Graphics g = e.Graphics;

		//int[] coords0 = new int[] {5,5, 80, 80 };
		
		//int[] coords0 = new int[] {30,30, 180,30,  180,180,  30,180};
        int iLen = coords0.Length;

        iLen -= 2;

		GraphicsPath path = new GraphicsPath();

		for(int i=0; i<iLen; i+=2)
		{
			path.AddLine(coords0[i+0], coords0[i+1], 
				    coords0[i+2], coords0[i+3]);
		}

		//path.AddLine(coords0[iLen-2], coords0[iLen-1], 
		//		     coords0[0], coords0[1]);

		// Create pen
		Pen redPen = new Pen( Color.Red, 1 );

		// Draw path to screen.
		g.DrawPath( redPen, path );

		// Now tidy up
		redPen.Dispose();

		// ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** //
		// Line from a fixed point to our mouse cursor position.
		double px = 400;
		double py = 500;

		g.DrawLine( new Pen(Color.Blue), (int)px, (int)py, (int)m_mouse_x, (int)m_mouse_y );

		// ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** //


	}// End of OnPaint(..)


	bool insidePoly( int[] coords, int x0, int y0 )
	{
		// Line far away that we can use to reference our point to.
		double px = 300;
		double py = 500;

		int iLen = coords.Length;
		iLen -= 2;

		int totalIntersections = 0;
		for(int i=0; i<iLen; i+=2)        
		{
			double p0x = coords[i+0];
			double p0y = coords[i+1];

			double p1x = coords[i+2];
			double p1y = coords[i+3];

			if( IntersectLines2D( p0x, p0y, p1x, p1y,
				                  px, py, m_mouse_x, m_mouse_y) > 0 )  totalIntersections++;

		}

		if( (totalIntersections % 2)==0 ) // even
			return true;
		else
			return false;
	}// End insidePoly(..)

	int IntersectLines2D( double p0x, double p0y, double p1x, double p1y,
		                  double p2x, double p2y, double p3x, double p3y)
	{
		// Uses parametric lines. (e.g. p = p0 + (p1-p0)*t ) where t is from 0 to 1;
		double p0vx  = p1x - p0x;
		double p0vy  = p1y - p0y;

		double p1vx  = p3x - p2x;
		double p1vy  = p3y - p2y;

        // Test -1- Check for parallel ines.  If the direction vectors are scalar
		// multiples then the lines are parallel and can't possibly intersect unless
		// the lines overlap
		double det_p0p1 = (p0vx*p1vy - p0vy*p1vx);
		if( Math.Abs( det_p0p1) <= 0.000001 )
		  return 0; // Parallel lines - hence no intersection

		// Test -2- Computer the t0 and t1 values for intersection, where we have
		// two lines of hte form
		// p = p0 + v*t
		// p1 = p10 + v1*t1

		// p1.x = p10.x + v1.x*t1
		// p1.y = p10.y + v1.y*t1

		// p2 = p20 + v2*t2

		// p2.x = p20.x + v2.x*t2
		// p2.y = p20.y + v2.y*t2
		// Solve the system when x1 = x2 and y1 = y2

		double t0 = (p1vx*(p0y - p2y) - p1vy*(p0x - p2x) ) / det_p0p1;
		double t1 = (p0vx*(p0y - p2y) - p0vy*(p0x - p2x) ) / det_p0p1;
		

		if( (t0>=0) && (t0<=1) && (t1>=0) && (t1<=1) )
			return 1; // We have an intersection
		else
			return 0; // Intersects out of bounds.

	}//End IntersectLines2D(..)


	void StartGame()
	{
		int[] start_coords = new int[] {20,69,27,69,32,73,33,78,26,84,22,85,17,81,18,73,22,69};

		if( !insidePoly( start_coords, m_mouse_x, m_mouse_y) ) 
		{
			m_bGameOver = false;
			fTiming = 0.0f;
			SetTextBoxInfo("Go Go Go....");
		}
	}

	void CheckGameWon()
	{
		if( m_bGameOver == true ) return;

		int[] won_coords = new int[] {272,65,279,66,282,71,282,76,278,80,271,79,267,75,267,69,272,65,272,65};

		if( !insidePoly( won_coords, m_mouse_x, m_mouse_y) ) 
		{
			m_bGameOver = false;
			fTiming = 0.0f;
			this.Text = "You Won - Congratulations";
			SetTextBoxInfo("You Won - Congratulations");
		}
	}//End CheckGameWon(..)


	private void OnMouseButtonEvent(object sender, System.Windows.Forms.MouseEventArgs e)
	{
			ChangeLevel();

		    ShowRules();

			StartGame();
	}

	void CheckOutsideMaze()
	{
		if( m_bGameOver == true ) return;

		if( !insidePoly( coords0, m_mouse_x, m_mouse_y)  )
		{
			m_bGameOver = true;
			SetTextBoxInfo("GameOver - Try Again");
		}
	}

	void ShowRules()
	{
		int[] rules_coords = new int[] {129,164,172,174};

		if( !insidePoly( rules_coords, m_mouse_x, m_mouse_y) ) 
		{
			SetTextBoxInfo("Click start (yellow circle left)");
		}
		
	}

    private void OnMouseMoveEvent(object sender, System.Windows.Forms.MouseEventArgs e)
    {
		int mouse_x = e.X;
		int mouse_y = e.Y;

		m_mouse_x = mouse_x;
		m_mouse_y = mouse_y;


		// Check if our mouse goes outside the maze!..hence its gameover.
		CheckOutsideMaze();

		if( e.Button == MouseButtons.Left )
		{
			ChangeLevel();
		}

		//Render();
    }

	private void Ticker_Tick(object sender, EventArgs e)
	{
		if( m_bGameOver == false )
		{
			UpdateGame();
		}

		Render();

	} // End of Ticker_Tick(..)


	void LevelButtonEffect( System.Drawing.Graphics g )
	{
		int ww = 2;
		int hh = 2;
		//int xx = 145;
		int yy = 180;
		//int gap = 10;
		Pen pen = new Pen( Color.Red, 1 );


		//g.DrawEllipse(pen, xx, yy, ww, hh);

		int[] level_1_coords = new int[] {144,185,152,196};
		int[] level_2_coords = new int[] {153,185,162,195};
		int[] level_3_coords = new int[] {164,184,172,195};
		int[] level_4_coords = new int[] {175,185,182,196};
		int[] level_5_coords = new int[] {185,184,192,196};
		
		if( !insidePoly( level_1_coords, m_mouse_x, m_mouse_y) ) g.DrawEllipse(pen, 147, yy, ww, hh);
		if( !insidePoly( level_2_coords, m_mouse_x, m_mouse_y) ) g.DrawEllipse(pen, 157, yy, ww, hh);
		if( !insidePoly( level_3_coords, m_mouse_x, m_mouse_y) ) g.DrawEllipse(pen, 167, yy, ww, hh);
		if( !insidePoly( level_4_coords, m_mouse_x, m_mouse_y) ) g.DrawEllipse(pen, 177, yy, ww, hh);
		if( !insidePoly( level_5_coords, m_mouse_x, m_mouse_y) ) g.DrawEllipse(pen, 188, yy, ww, hh);

	}

	void ChangeLevel()
	{
		int[] level_1_coords = new int[] {144,185,152,196};
		int[] level_2_coords = new int[] {153,185,162,195};
		int[] level_3_coords = new int[] {164,184,172,195};
		int[] level_4_coords = new int[] {175,185,182,196};
		int[] level_5_coords = new int[] {185,184,192,196};
		
		if( !insidePoly( level_1_coords, m_mouse_x, m_mouse_y) ) m_level = 1;
		if( !insidePoly( level_2_coords, m_mouse_x, m_mouse_y) ) m_level = 2;
		if( !insidePoly( level_3_coords, m_mouse_x, m_mouse_y) ) m_level = 3;
		if( !insidePoly( level_4_coords, m_mouse_x, m_mouse_y) ) m_level = 4;
		if( !insidePoly( level_5_coords, m_mouse_x, m_mouse_y) ) m_level = 5;
	}


	private void Create()
	{
		m_Metiors = new Metiors[5];

		m_Metiors[0] = new Metiors();
		m_Metiors[0].SetRandSeed();

		for(int i=0; i<5; i++)
		{
			m_Metiors[i] = new Metiors();
			String str = "img\\" + "dangerpic" + (i+1).ToString() + ".gif";
			m_Metiors[i].Create(str);
		}
	}

	private void UpdateGame()
	{
		fTiming += 0.121f;

		for(int i=0; i<5; i++)
		{
			m_Metiors[i].Update();
		}

		bool bCollision = false;
		for(int i=0; i<5; i++)
		{
			bCollision = m_Metiors[i].isInsideBox(m_mouse_x, m_mouse_y);
			if( bCollision ) break;
		}   

		CheckGameWon();

		if( bCollision )
		{
			SetTextBoxInfo("Crash...Start again");
			m_bGameOver = true;
		}

	}

	AWindow()
	{
		this.ClientSize = new System.Drawing.Size(300,246);

		this.Screen = new System.Windows.Forms.PictureBox();
		this.Screen.Name = "Screen";
		this.Screen.Size = new System.Drawing.Size(300, 246);

		this.Screen.MouseMove += new System.Windows.Forms.MouseEventHandler(this.OnMouseMoveEvent);
		this.Screen.MouseDown += new System.Windows.Forms.MouseEventHandler(this.OnMouseButtonEvent);

		// We need to add our screen buffer to our window
		this.Controls.AddRange(new System.Windows.Forms.Control[] {this.Screen});

		/* ------------ */
		this.components = new System.ComponentModel.Container();

		/* ------------ */

		this.Ticker = new System.Windows.Forms.Timer(this.components);
		this.Ticker.Interval = 25;
		this.Ticker.Tick += new System.EventHandler(this.Ticker_Tick);

		/* ------------ */
		Ticker.Enabled = true;

		/* ------------ */

		// Load all game images
		Create();

		// Render to our backbuffer/screen.
		Render();
	}// End of AWindow()

	// Application Entry Point
	static void Main()
	{
		System.Windows.Forms.Application.Run(new AWindow());
	}// End Main()
}// End of AWindow class


